<template>
    <div class="container-fluid">
        <div class="row justify-content-center">
            <div class="col-8">
                <div class="card mt-5">
                    <div class="card-header">
                        Upload Company Data Excel
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-12">
                                <div class="custom-file">
                                    <input
                                        type="file"
                                        class="custom-file-input"
                                        ref="import_file"
                                        @change="onFileChange"
                                    />
                                    <label
                                        class="custom-file-label"
                                        for="validatedCustomFile"
                                        >{{
                                            import_file
                                                ? import_file.name
                                                : "Choose file..."
                                        }}</label
                                    >
                                </div>
                            </div>
                        </div>
                        <div
                            class="alert alert-danger mt-3 mb-0"
                            v-if="error.message"
                        >
                            {{ error.message }}
                        </div>
                        <div
                            class="alert alert-success mt-3 mb-0"
                            v-if="success"
                        >
                            Данные загружены в БД
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-10 mt-3 mb-3" v-if="success">
                <vue-bootstrap4-table
                    :rows="rows"
                    :columns="columns"
                    :config="config"
                ></vue-bootstrap4-table>
            </div>
            <div class="col-8" v-if="success">
                <div class="card mt-3">
                    <div class="card-header">
                        Choose company name
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-12">
                                <select
                                    class="form-control"
                                    v-model="company"
                                    @change="getData()"
                                >
                                    <option value="0">Select company</option>

                                    <option
                                        v-for="data in companies"
                                        :value="data.company"
                                        >{{ data.company }}</option
                                    >
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-10 mt-3 mb-3" v-if="success">
                <div class="row">
                    <div class="col-6 pr-0">
                        <div class="card">
                            <div class="card-header">
                                Fact
                            </div>
                            <div class="card-body">
                                <apexchart
                                    type="line"
                                    height="350"
                                    :options="chartOptions"
                                    :series="seriesFact"
                                ></apexchart>
                            </div>
                        </div>
                    </div>
                    <div class="col-6">
                        <div class="card">
                            <div class="card-header">
                                Forecast
                            </div>
                            <div class="card-body">
                                <apexchart
                                    type="line"
                                    height="350"
                                    :options="chartOptions"
                                    :series="seriesForecast"
                                ></apexchart>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import VueBootstrap4Table from "vue-bootstrap4-table";
import VueApexCharts from "vue-apexcharts";
export default {
    components: {
        apexchart: VueApexCharts
    },
    data() {
        return {
            error: {},
            import_file: "",
            success: false,
            company: 0,
            companies: [],
            rows: [],
            columns: [
                {
                    label: "id",
                    name: "id",
                    sort: true
                },
                {
                    label: "Company",
                    name: "company",
                    sort: true
                },
                {
                    label: "Fact / Forecast",
                    name: "fact_forecast",
                    sort: true
                },
                {
                    label: "Qliq",
                    name: "qliq",
                    sort: true
                },
                {
                    label: "Qoil",
                    name: "qoil",
                    sort: true
                },
                {
                    label: "Date",
                    name: "date",
                    sort: true
                }
            ],
            config: {
                checkbox_rows: true,
                rows_selectable: true,
                card_title: "Company List",
                show_refresh_button: false,
                show_reset_button: false
            },
            seriesFact: [],
            seriesForecast: [],
            chartOptions: {
                chart: {
                    height: 350,
                    type: "line",
                    dropShadow: {
                        enabled: true,
                        color: "#000",
                        top: 18,
                        left: 7,
                        blur: 10,
                        opacity: 0.2
                    },
                    toolbar: {
                        show: false
                    }
                },
                colors: ["#77B6EA", "#545454"],
                dataLabels: {
                    enabled: true
                },
                stroke: {
                    curve: "smooth"
                },
                grid: {
                    borderColor: "#e7e7e7",
                    row: {
                        colors: ["#f3f3f3", "transparent"], // takes an array which will be repeated on columns
                        opacity: 0.5
                    }
                },
                markers: {
                    size: 1
                },
                xaxis: {
                    categories: ["2020-01-01", "2020-01-02"],
                    title: {
                        text: "Dates"
                    }
                },
                legend: {
                    position: "top",
                    horizontalAlign: "right",
                    floating: true,
                    offsetY: -25,
                    offsetX: -5
                }
            }
        };
    },
    methods: {
        onFileChange(e) {
            this.import_file = e.target.files[0];
            this.proceedAction();
        },
        proceedAction() {
            let formData = new FormData();
            formData.append("import_file", this.import_file);
            this.success = false;
            this.error = {};
            axios
                .post("/companies/import", formData, {
                    headers: { "content-type": "multipart/form-data" }
                })
                .then(response => {
                    if (response.status === 200) {
                        this.rows = response.data;
                        this.success = true;
                        this.getCompanies();
                    } else {
                        this.error = response;
                    }
                })
                .catch(error => {
                    this.error = error.response.data;
                });
        },
        getCompanies: function() {
            axios.get("/companies/getCompanies").then(
                function(response) {
                    this.companies = response.data;
                }.bind(this)
            );
        },
        getData: function() {
            axios.get("/companies/getCompanyData/" + this.company).then(
                function(response) {
                    this.seriesFact = [
                        {
                            name: "Qliq",
                            data: response.data.fact.map(data => data.qliq)
                        },
                        {
                            name: "Qoil",
                            data: response.data.fact.map(data => data.qoil)
                        }
                    ];
                    this.seriesForecast = [
                        {
                            name: "Qliq",
                            data: response.data.forecast.map(data => data.qliq)
                        },
                        {
                            name: "Qoil",
                            data: response.data.forecast.map(data => data.qoil)
                        }
                    ];
                }.bind(this)
            );
        }
    }
};
</script>
